use Socket;
use Getopt::Std;
use Sys::Hostname;

getopts('h:p:t');
$message = $ARGV[0];

# checking command line arguments
if (!$opt_h || !$opt_p)
{	
	die "Usage: perl rlogger.pl -h <hostname> -p <port> message\n";
} 

$ipaddr = inet_aton($opt_h);
$PORTNO = $opt_p;

$now = &computeLocaltime();
$header = &computeHeader();

if ($opt_t)
{
}
else
{
	socket(SOCKET, PF_INET, SOCK_DGRAM, getprotobyname("udp"));
	$portaddr = sockaddr_in($PORTNO, $ipaddr);
	send(SOCKET, $header, 0, $portaddr) == length($header)
}

sub computeHeader
{
        my $header;
	$hname = hostname;
        $header = "<0>$now $hname rlogger.pl: $message";
        return $header;
}

sub computeLocaltime
{
	my @months, $time;
	@months = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
	
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

	$time = $months[$mon] . " " . &addLS($mday) . " " . &addLZ($hour) . ":" . &addLZ($min) . ":" . &addLZ($sec);
	return $time;
}

sub addLZ
{
	$value = pop(@_);
	if ($value < 9)
	{
		return "0" . $value;
	}
	else
	{
		return $value;
	}
}

sub addLS
{
        $value = pop(@_);
        if ($value < 9)
        {
                return " " . $value;
        }
        else
        {
                return $value;
        }
}

